## batctl 2024.4

=== debian/changelog ===
batctl (2024.4-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Sven Eckelmann <sven@narfation.org>  Mon, 16 Dec 2024 11:08:06 +0100

batctl (2024.4-1) unstable; urgency=medium

  * New Upstream Version

 -- Sven Eckelmann <sven@narfation.org>  Tue, 10 Dec 2024 21:42:19 +0100

batctl (2024.3-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Sven Eckelmann <sven@narfation.org>  Sun, 20 Oct 2024 11:10:16 +0200

batctl (2024.2-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Sven Eckelmann <sven@narfation.org>  Sat, 29 Jun 2024 09:50:32 +0200

batctl (2024.1-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * debian/rules:
    - switch back to CPPFLAGS instead of not yet available abi=+lfs

 -- Sven Eckelmann <sven@narfation.org>  Thu, 18 Apr 2024 17:27:06 +0200

batctl (2024.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Sven Eckelmann <sven@narfation.org>  Sun, 03 Mar 2024 19:14:15 +0100

## batctl 2025.0

=== debian/changelog ===
batctl (2025.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Sven Eckelmann <sven@narfation.org>  Wed, 12 Feb 2025 09:47:21 +0100

batctl (2025.0-1) unstable; urgency=medium

  * New Upstream Version

 -- Sven Eckelmann <sven@narfation.org>  Fri, 07 Feb 2025 11:19:42 +0100

=== debian/control ===
Source: batctl
Section: net
Priority: optional
Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
Uploaders:
 Simon Wunderlich <sw@simonwunderlich.de>,
 Sven Eckelmann <sven@narfation.org>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.open-mesh.org/
Vcs-Git: https://salsa.debian.org/communitywlan-team/batctl.git -b debian/bookworm-backports
Vcs-Browser: https://salsa.debian.org/communitywlan-team/batctl
Build-Depends:
 debhelper-compat (= 13),
 libnl-3-dev,
 libnl-genl-3-dev,
 pkgconf,

Package: batctl
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: B.A.T.M.A.N. advanced control and management tool
 This package contains batctl, which serves as configuration utility,
 monitoring and debugging application. It allows one to modify the module
 parameters, reading the logfiles and tables, decapsulate embedded packets on
 the fly, traceroute to and ping mac addresses, generate sequence number graphs
 for the Layer 2 Mesh B.A.T.M.A.N.
 .
 B.A.T.M.A.N. (better approach to mobile ad-hoc networking) is a new routing
 protocol for multi-hop ad-hoc mesh networks. B.A.T.M.A.N.-advanced is the
 implementation of this protocol on ISO/OSI Layer 2, allowing mesh networks to
 be used as a virtual switch. With this approach, LANs and WANs can be easily
 integrated, and more protocols (like DHCP, IPv6) are supported.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

export PKG_CONFIG ?= pkg-config
export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto
export DEB_CFLAGS_MAINT_APPEND = -fdata-sections -ffunction-sections
export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--gc-sections

MAKEOPTIONS = V="1" REVISION="debian-$(DEB_VERSION)" PREFIX="/usr" CONFIG_bisect_iv=y

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.rst

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_build override_dh_auto_install override_dh_installchangelogs

## batctl 2025.2

=== debian/changelog ===
batctl (2025.2-1) experimental; urgency=medium

  * New Upstream Version

 -- Sven Eckelmann <sven@narfation.org>  Thu, 19 Jun 2025 00:05:20 +0200

batctl (2025.1-1) experimental; urgency=medium

  * New Upstream Version

 -- Sven Eckelmann <sven@narfation.org>  Mon, 21 Apr 2025 17:18:48 +0200

batctl (2025.0-2) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.7.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 01 Mar 2025 20:57:40 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders:
  Simon Wunderlich <sw@simonwunderlich.de>,
  Sven Eckelmann <sven@narfation.org>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://www.open-mesh.org/
-Vcs-Git: https://salsa.debian.org/communitywlan-team/batctl.git -b debian/bookworm-backports
+Vcs-Git: https://salsa.debian.org/communitywlan-team/batctl.git -b debian/experimental
 Vcs-Browser: https://salsa.debian.org/communitywlan-team/batctl
 Build-Depends:
  debhelper-compat (= 13),

## batctl 2025.3

=== debian/changelog ===
batctl (2025.3-1) unstable; urgency=medium

  * New Upstream Version

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Sep 2025 15:23:51 +0200

## batctl 2025.4

=== Makefile ===
#!/usr/bin/make -f
# SPDX-License-Identifier: GPL-2.0
# -*- makefile -*-
#
# Copyright (C) B.A.T.M.A.N. contributors
#
# License-Filename: LICENSES/preferred/GPL-2.0

# just for backward compatibility - please use CONFIG_bisect_iv instead
export CONFIG_BATCTL_BISECT=n

# batctl build
BINARY_NAME = batctl

obj-y += bat-hosts.o
obj-y += debug.o
obj-y += functions.o
obj-y += genl.o
obj-y += genl_json.o
obj-y += hash.o
obj-y += icmp_helper.o
obj-y += main.o
obj-y += netlink.o
obj-y += sys.o

define add_command
  CONFIG_$(1):=$(2)
  ifneq ($$(CONFIG_$(1)),y)
    ifneq ($$(CONFIG_$(1)),n)
      $$(warning invalid value for parameter CONFIG_$(1): $$(CONFIG_$(1)))
    endif
  endif

  obj-$$(CONFIG_$(1)) += $(1).o
endef # add_command

# using the make parameter CONFIG_* (e.g. CONFIG_bisect_iv) with the value 'y'
# enables the related feature and 'n' disables it
$(eval $(call add_command,aggregation,y))
$(eval $(call add_command,ap_isolation,y))
$(eval $(call add_command,backbonetable,y))
$(eval $(call add_command,bisect_iv,$(CONFIG_BATCTL_BISECT)))
$(eval $(call add_command,bla_backbone_json,y))
$(eval $(call add_command,bla_claim_json,y))
$(eval $(call add_command,bonding,y))
$(eval $(call add_command,bridge_loop_avoidance,y))
$(eval $(call add_command,claimtable,y))
$(eval $(call add_command,dat_cache,y))
$(eval $(call add_command,dat_cache_json,y))
$(eval $(call add_command,distributed_arp_table,y))
$(eval $(call add_command,elp_interval,y))
$(eval $(call add_command,event,y))
$(eval $(call add_command,fragmentation,y))
$(eval $(call add_command,gateways,y))
$(eval $(call add_command,gateways_json,y))
$(eval $(call add_command,gw_mode,y))
$(eval $(call add_command,hardif_json,y))
$(eval $(call add_command,hardifs_json,y))
$(eval $(call add_command,hop_penalty,y))
$(eval $(call add_command,interface,y))
$(eval $(call add_command,isolation_mark,y))
$(eval $(call add_command,loglevel,y))
$(eval $(call add_command,mcast_flags,y))
$(eval $(call add_command,mcast_flags_json,y))
$(eval $(call add_command,mesh_json,y))
$(eval $(call add_command,multicast_fanout,y))
$(eval $(call add_command,multicast_forceflood,y))
$(eval $(call add_command,multicast_mode,y))
$(eval $(call add_command,neighbors,y))
$(eval $(call add_command,neighbors_json,y))
$(eval $(call add_command,orig_interval,y))
$(eval $(call add_command,originators,y))
$(eval $(call add_command,originators_json,y))
$(eval $(call add_command,ping,y))
$(eval $(call add_command,routing_algo,y))
$(eval $(call add_command,statistics,y))
$(eval $(call add_command,tcpdump,y))
$(eval $(call add_command,throughput_override,y))
$(eval $(call add_command,throughputmeter,y))
$(eval $(call add_command,traceroute,y))
$(eval $(call add_command,transglobal,y))
$(eval $(call add_command,translate,y))
$(eval $(call add_command,translocal,y))
$(eval $(call add_command,transtable_global_json,y))
$(eval $(call add_command,transtable_local_json,y))
$(eval $(call add_command,vlan_json,y))

MANPAGE = man/batctl.8

# batctl flags and options
CFLAGS += -Wall -W -std=gnu99 -fno-strict-aliasing -MD -MP
CPPFLAGS += -D_GNU_SOURCE
LDLIBS += -lm -lrt

# disable verbose output
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	Q_CC = @echo '   ' CC $@;
	Q_LD = @echo '   ' LD $@;
	export Q_CC
	export Q_LD
endif
endif

ifeq ($(origin PKG_CONFIG), undefined)
  PKG_CONFIG = pkg-config
  ifeq ($(shell which $(PKG_CONFIG) 2>/dev/null),)
    $(error $(PKG_CONFIG) not found)
  endif
endif

ifeq ($(origin LIBNL_CFLAGS) $(origin LIBNL_LDLIBS), undefined undefined)
  LIBNL_NAME ?= libnl-3.0
  ifeq ($(shell $(PKG_CONFIG) --modversion $(LIBNL_NAME) 2>/dev/null),)
    $(error No $(LIBNL_NAME) development libraries found!)
  endif
  LIBNL_CFLAGS += $(shell $(PKG_CONFIG) --cflags $(LIBNL_NAME))
  LIBNL_LDLIBS +=  $(shell $(PKG_CONFIG) --libs $(LIBNL_NAME))
endif
CFLAGS += $(LIBNL_CFLAGS)
LDLIBS += $(LIBNL_LDLIBS)

ifeq ($(origin LIBNL_GENL_CFLAGS) $(origin LIBNL_GENL_LDLIBS), undefined undefined)
  LIBNL_GENL_NAME ?= libnl-genl-3.0
  ifeq ($(shell $(PKG_CONFIG) --modversion $(LIBNL_GENL_NAME) 2>/dev/null),)
    $(error No $(LIBNL_GENL_NAME) development libraries found!)
  endif
  LIBNL_GENL_CFLAGS += $(shell $(PKG_CONFIG) --cflags $(LIBNL_GENL_NAME))
  LIBNL_GENL_LDLIBS += $(shell $(PKG_CONFIG) --libs $(LIBNL_GENL_NAME))
endif
CFLAGS += $(LIBNL_GENL_CFLAGS)
LDLIBS += $(LIBNL_GENL_LDLIBS)

# standard build tools
CC ?= gcc
RM ?= rm -f
INSTALL ?= install
MKDIR ?= mkdir -p
COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.o = $(Q_LD)$(CC) $(CFLAGS) $(LDFLAGS) $(TARGET_ARCH)

# standard install paths
PREFIX = /usr/local
SBINDIR = $(PREFIX)/sbin
MANDIR = $(PREFIX)/share/man

# try to generate revision
REVISION= $(shell	if [ -d .git ]; then \
				echo $$(git describe --always --dirty --match "v*" |sed 's/^v//' 2> /dev/null || echo "[unknown]"); \
			fi)
ifneq ($(REVISION),)
CPPFLAGS += -DSOURCE_VERSION=\"$(REVISION)\"
endif

# default target
all: $(BINARY_NAME)

# standard build rules
.SUFFIXES: .o .c
.c.o:
	$(COMPILE.c) -o $@ $<

$(BINARY_NAME): $(obj-y)
	$(LINK.o) $^ $(LDLIBS) -o $@

clean:
	$(RM) $(BINARY_NAME) $(obj-y) $(obj-n) $(DEP)

install: $(BINARY_NAME)
	$(MKDIR) $(DESTDIR)$(SBINDIR)
	$(MKDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 0755 $(BINARY_NAME) $(DESTDIR)$(SBINDIR)
	$(INSTALL) -m 0644 $(MANPAGE) $(DESTDIR)$(MANDIR)/man8

# load dependencies
DEP = $(obj-y:.o=.d) $(obj-n:.o=.d)
-include $(DEP)

.PHONY: all clean install

=== debian/changelog ===
batctl (2025.4-1) unstable; urgency=medium

  * New Upstream Version

 -- Sven Eckelmann <sven@narfation.org>  Sat, 25 Oct 2025 11:10:59 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://www.open-mesh.org/
-Vcs-Git: https://salsa.debian.org/communitywlan-team/batctl.git -b debian/experimental
+Vcs-Git: https://salsa.debian.org/communitywlan-team/batctl.git -b debian/unstable
 Vcs-Browser: https://salsa.debian.org/communitywlan-team/batctl
 Build-Depends:
  debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,8 @@
 include /usr/share/dpkg/pkg-info.mk
 
 export PKG_CONFIG ?= pkg-config
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto abi=+lfs
 export DEB_CFLAGS_MAINT_APPEND = -fdata-sections -ffunction-sections
-export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--gc-sections
 
 MAKEOPTIONS = V="1" REVISION="debian-$(DEB_VERSION)" PREFIX="/usr" CONFIG_bisect_iv=y

=== debian/watch ===
version=4
opts="uversionmangle=s/-(alpha|beta|rc)/~$1/,pgpsigurlmangle=s/$/.asc/" \
 https://downloads.open-mesh.org/batman/stable/sources/batctl/batctl-(.*).tar.gz

## batctl 2025.5

=== debian/changelog ===
batctl (2025.5-1) unstable; urgency=medium

  * New Upstream Version
  * debian/watch:
    - Switch to version 5 format

 -- Sven Eckelmann <sven@narfation.org>  Sat, 20 Dec 2025 22:34:11 +0100
